=begin
Copyright 2014, Chris Fullmer
All Rights Reserved

Disclaimer
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

License
This software is distributed under the Smustard End User License Agreement
http://www.smustard.com/eula

Information
Author - Chris Fullmer
Organization - www.ChrisFullmer.com and distributed on the Extension Warehouse
Name - Simple Loft
SU Version - 2014, 2013, 8, 7

Description
This script smoothly connects curves/splines

Usage
Activate the script.  Then select a "spline" or series of connected lines, and select as 
many splines as you desire.  Then hit enter and wait a long time.

History
0.1a:: 2009-05-14
   * First release alpha test realease
0.1b:: 2009-05-15
   * Added bezier curving between splines - this is sort of what makes a loft different than just connecting with straight lines.  So its a major accomplishment over the previous release.
0.2.0 - 2013-05-20
  * EW Compatible
0.3.0 - 2014-1-10
  * Ruby Compatibility
  * Having this script loaded no longer "dirties the model".  You won't be asked to save the model when you close it when no changes were made to the model.

=end

module CLF_Extensions_NS
  
  module CLF_Simple_Loft            #EDIT
    require 'sketchup.rb'
    require 'extensions.rb'
    
    NAME = "clf_simple_loft"        #EDIT
    UNAME = "CLF Simple Loft"       #EDIT
    MENU_NAME = "Simple Loft"       #EDIT
    version = "0.3.0"           #EDIT
    desc = "This plugin takes welded curves and creates geometry using a lofting technique."
    copy_year = "2014"
    author = "Chris Fullmer"
    
#------edit above--------------------------------------------------------------- 

    
    extension = SketchupExtension.new UNAME, NAME+"/"+NAME+"_menus.rb"

    #The name= method sets the name which appears for an extension inside the Extensions Manager dialog.
    extension.name = UNAME

    # The description= method sets the long description which appears beneath an extension inside the Extensions Manager dialog.
    extension.description = desc + "  Access it via Plugins > Chris Fullmer Tools > "+MENU_NAME

    # The version method sets the version which appears beneath an extension inside the Extensions Manager dialog.
    extension.version = version

    # Create an entry in the Extension list that loads a script called
    # stairTools.rb.
    extension.copyright = copy_year
     
    # The creator= method sets the creator string which appears beneath an extension inside the Extensions Manager dialog.
    extension.creator = author

    # The register_extension method is used to register an extension with SketchUp's extension manager (in SketchUp preferences).
    Sketchup.register_extension( extension, true )
    
  end
end