# See the loader file for license and author info

require 'sketchup.rb'
module CLF_Extensions_NS
	module CLF_Simple_Loft

    class Clf_loft

      def activate
        @model = Sketchup.active_model
        @ents = @model.entities
        @sel = @model.selection
        @sel.clear
        @model.start_operation("简单放样", true)
        @shapes = []
        @shapes_edges = []
        @lengths = []
        @start_end = []
        @shape_normal = []
        @first_shape = true
        @current_start_point = []
        @seg_lengths = []
        @handles = []
        @shell = @ents.add_group
      end # activate
      
      def deactivate(view)
        Sketchup.send_action "selectSelectionTool:"
      end # deactivate
      
      def onLButtonUp(flags, x, y, view)
        ph = view.pick_helper
        ph.do_pick x,y
        best = ph.best_picked
        all_best = best.all_connected
        @shapes_edges << best.all_connected
        @sel.add all_best
        @first_shape = false if @shapes.length > 0
        ordered = order_points all_best
        @shapes << ordered
        length = shape_length all_best
        @lengths << length
        sl = seg_lengths(ordered)
        @seg_lengths << sl
      end # onLButtonUp
      
      def onReturn(view)
        if @shapes.length > 1
          values = [5]
          seg_handles = []
          start_handle = []
          end_handle = []
          prompts = ["有多少个段数？"]
          results = UI.inputbox prompts, values, "细分段数"
          segs = results[0]
          @sel.clear
          start_handle = end_handles( @shapes[0], @shapes[1] )
          
          if @shapes.length > 2
            (@shapes.length.-2).times do |e|
              seg_handles = middle_handles( @shapes[e+1], @shapes[e], @shapes[e+2] )
              end_handle = seg_handles[0]
              @handles[e] = [start_handle, end_handle]
              start_handle = seg_handles[1]
            end
          end
          last_position = @handles.length
          end_handle = end_handles( @shapes[((@shapes.length)-1)], @shapes[((@shapes.length)-2)] )
          @handles[(last_position)] = [start_handle, end_handle]
          
          (@shapes.length-1).times do |e|
            make_shell(@shapes[e], @handles[e][0], @shapes[e+1], @handles[e][1], segs)
          end
          temp_group = @ents.add_group(@shell)
          gents = temp_group.entities
          gents[0].explode
          
          
          
          @model.commit_operation
          Sketchup.send_action "selectSelectionTool:"
        else
          UI.messagebox "请选择2个不同的线"
        end
      end # onReturn
      
      
      def middle_handles( points, prepoints, postpoints )
        point_array1 = []
        point_array2 = []
        new_vec = []
        hz_vec = []
        handle_vec = []
        s1p1 = []
        s1p2 = []
        s2p1 = []
        s2p2 = []
        orig_vec1 = []
        orig_vec2 = []
        mp1 = []
        mp2 = []
        zvec = []
        vec1 = []
        vec2 = []
        line1 = []
        line2 = []
        pt = []
        d1 = 0
        d2 = 0		
        testpt1 = []
        points.each_index do |e|
          s1p1 = points[e]
          s1p2 = prepoints[e]
          s2p1 = points[e]
          s2p2 = postpoints[e]
          orig_vec1 = s1p1.vector_to s1p2
          orig_vec2 = s2p1.vector_to s2p2
          mp1 = Geom.linear_combination 0.5, s1p1, 0.5, s1p2
          mp2 = Geom.linear_combination 0.5, s2p1, 0.5, s2p2
          if orig_vec1.parallel? orig_vec2
            pt1 = mp1
            pt2 = mp2
          else
            zvec = orig_vec1.cross orig_vec2
            vec1 = orig_vec1.cross zvec
            vec2 = orig_vec2.cross zvec
            line1 = [mp1, vec1]
            line2 = [mp2, vec2]
            pt = Geom.intersect_line_line(line1, line2)
            new_vec = pt.vector_to points[e]
            hz_vec = new_vec.cross orig_vec1
            hz_vec.normalize!
            testpt1 = points[e].clone.offset hz_vec
            handle_vec = hz_vec.cross new_vec
            testpt1 = points[e].clone.offset handle_vec
            pt1 = points[e].clone
            d1 = (points[e].distance prepoints[e]) / 2
            d2 = (points[e].distance postpoints[e]) / 2
            handle_vec.length = d1
            pt1.offset! handle_vec
            pt2 = points[e].clone
            handle_vec.length = d2
            pt2.offset! handle_vec.reverse!
          end
          point_array1 << pt1.clone
          point_array2 << pt2.clone
        end	
        [point_array1, point_array2]
      end # middle_handles
      
      def end_handles( start_points, end_points )
        point_array = []
        point2 = []
        length = 0
        distance = 0
        temp_group1 = @ents.add_group()
        gents1 = temp_group1.entities
        temp_group2 = @ents.add_group()
        gents2 = temp_group2.entities
        start_points.each_index do |e|
          #### --Do not remove these cpoints - they are part of the script --
          gents1.add_cpoint start_points[e]
          gents2.add_cpoint end_points[e]
          #### --Do not remove these cpoints - they are part of the script --
        end # end_handles
        
        sppt = temp_group1.bounds.center
        eppt = temp_group2.bounds.center
        vec = sppt.vector_to eppt
        @ents.erase_entities [temp_group1, temp_group2]
        start_points.each_index do |e|
          distance = start_points[e].distance end_points[e]
          length = distance/2
          vec.length = length
          point2 = start_points[e].offset vec
          point_array << point2
        end
        point_array	
      end
      
      def shape_length(edges)
        length = 0
        edges.each do |e|
          length += e.length
        end
        length
      end # shape_length
      
      def seg_lengths(ordered_points)
        seg_lengths = []
        distance = 0.0
        (ordered_points.length-1).times do |p|
          distance = ordered_points[p].distance ordered_points[p+1]
          seg_lengths << distance
        end
        seg_lengths
      end	# seg_lengths
      
      def order_points(curve)
        edge = []
        allverts = []
        temp_edge = [] 
        arc_first = true
        vert_array = []
        start_vert = []
        arc_endverts = []
        curve.each do |e|
          allverts << e.start << e.end
        end
        allverts.uniq!
        allverts.each do |e| 
          if e.edges.length == 1
            arc_endverts << e
          end
        end
        if !@first_shape

          d1 = @current_start_point.distance arc_endverts[0].position
          d2 = @current_start_point.distance arc_endverts[1].position
          arc_endverts.reverse! if d1 > d2
        end
        cc=0
        start_vert = [arc_endverts[0]]
        @current_start_point = arc_endverts[0].position.clone
        curve.length.times do
          vert_array << start_vert[0].position.clone
          #@ents.add_text cc.to_s, start_vert[0].position
          if arc_first
            edge = start_vert[0].edges
          else
            two_edges = start_vert[0].edges
            edge = two_edges - temp_edge
          end
          temp_edge = edge
          two_verts = edge[0].vertices
          start_vert = two_verts - start_vert
          arc_first = false
          cc+=1
        end
        vert_array << arc_endverts[1].position.clone
        #@ents.add_text cc.to_s, start_vert[0].position
        vert_array
      end # order_points
      
      def make_shell( p0, p1, p2, p3, segs )
        temp = []
        bc = []
        gents = @shell.entities
        p0.length.times do |cc|
          temp = bezier_points( p0[cc], p1[cc], p2[cc], p3[cc], segs )
          bc << temp
        end
        cc1 = 0
        cc2 = 0
        while cc1 < (bc.length - 1) do
          while cc2 < (bc[cc1].length - 1 ) do
            fp0 = bc[cc1][cc2]
            fp1 = bc[cc1+1][cc2]
            fp2 = bc[cc1+1][cc2+1]
            fp3 = bc[cc1][cc2+1]
            face1 = gents.add_face( [fp0, fp1, fp3] )
            face2 = gents.add_face( [fp1, fp2, fp3] )
            face1.edges.each do |edges|
              edges.soft=true
              edges.smooth=true
            end
            face2.edges.each do |edges|
              edges.soft=true
              edges.smooth=true
            end
            cc2+=1
          end
          cc1+=1
          cc2=0
        end
      end # make_shell

	
      def bezier_points( p0, p1, p3, p2, segs )
        point_array = []
        np = [0,0,0]
        cx = (3 * (p1[0] - p0[0]))
        bx = (3 * (p2[0] - p1[0])) - cx
        ax = (p3[0] - p0[0]) - cx - bx
        cy = (3 * (p1[1] - p0[1]))
        by = (3 * (p2[1] - p1[1])) - cy
        ay = (p3[1] - p0[1]) - cy - by
        cz = (3 * (p1[2] - p0[2]))
        bz = (3 * (p2[2] - p1[2])) - cz
        az = (p3[2] - p0[2]) - cz - bz
        (segs.to_i+1).times do |e|
          t = e/segs.to_f
          np[0] = (ax*(t**3)) + (bx*(t**2)) + (cx*t) + p0[0]
          np[1] = (ay*(t**3)) + (by*(t**2)) + (cy*t) + p0[1]
          np[2] = (az*(t**3)) + (bz*(t**2)) + (cz*t) + p0[2]
          point_array << np.clone
        end
        point_array
      end # clf_bezier_points
      
    end # class
    #Sketchup.active_model.select_tool Clf_loft.new
  end
end

